/*	
 *	main.c
 *
 *	Vv~TC
 *
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sat Jun 29 06:45:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <piece.h>
#include <simple.h>
#include <s1c33cpu.h>

/****************************************************************************
 *	^E萔
 ****************************************************************************/

#define FPS		20			/* Q[x   */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ */

#define HISCORE_FNAME	"smiss.sav"	/* nCXRAZ[ut@C */
#define SCORE_MAX	999999		/* XRAől               */

/* XvCgv[ */
#define OBJ_CURSOR	63	/* J[\ */
#define N_OBJS		64

/* J[\ */
#define CURSOR_CENT_X	3	/* XvCgォ璆SWւ̃ItZbg */
#define CURSOR_CENT_Y	3	/* iEE㉺Słj         */
#define CURSOR_SPD	3	/* ړx                                 */
#define CURSOR_X_MIN	3
#define CURSOR_X_MAX	(DISP_X -  4)
#define CURSOR_Y_MIN	3
#define CURSOR_Y_MAX	(DISP_Y - 24)
typedef struct _CURSOR {
	short x, y;		/* SW */
} CURSOR;

/* n */
#define N_BASES		 2	/* n̐                                 */
#define BASE_CENT_X	10	/* XvCgォ璆SWւ̃ItZbg */
#define BASE_CENT_Y	 0	/* iEE㉺[Słj         */
#define BASE_CHAM_MAX	10	/* ő~TC */
#define CHR_CHEM	0xba	/* L(2x1)AсF|00 01| XRA\p  */
/* X */
#define N_CITIES	4	/* X̐                                   */
#define CITY_CENT_X	7	/* XvCgォ璆SWւ̃ItZbg */
#define CITY_CENT_Y	7	/* iEE㉺[Słj         */
#define CHR_CITY	0xaa	/* L(2x1)AсF|00 01|               */
/* nEX */
#define N_UNITS		(N_BASES + N_CITIES)
typedef struct _UNIT {
	short alive;		/* nFc~TC(0`BASE_CHAM_MAX)  */
				/* X@FtO(1:Ă/0:ł) */
	short x, y;		/* SW                         */
} UNIT;

/*  */
#define N_EXPLS		48	/* ̐iőj */
#define EXPL_SPD	128	/* Aj[VXs[h(8.8rbg) */
typedef struct _EXPL {
	short r;		/* a(0:) */
	short x, y;		/* SW     */
	short cnt;		/* Aj[VJE^(8.8rbg) */
} EXPL;

/* ~TC */
#define N_PATRS		 4	/* }~TC̐     */
#define N_SCUDS		24	/* XJbh~TC̐ */
#define SPLIT_Y_MIN	16	/* XJbh~TC\x */
#define SPLIT_Y_MAX	56
#define MISS_TYPE_PATR	 1
#define MISS_TYPE_SCUD	 2
typedef struct _MISS {
	short type;		/* 0:/1:}/2:XJbh   */
	short x, y;		/* ݍW                   */
	short sx, sy;		/* ˍW                   */
	short dx, dy;		/* ڕWW                   */
	short spd;		/* BԁiقǑj */
	short cnt;		/* oߎ                   */
	/* ȍ~́AXJbh~TĈݎgp */
	UNIT* target;		/* ڕWjbg               */
	struct _MISS* parent;	/* e~TC(NULL:[g)    */
	short split_cnt;	/*                    */
	short children;		/* q̐                     */
} MISS;

/* nʂ̃C */
const short gnd_pts[][2] = {
	{  0,80},{ 19,80},{ 27,72},{ 29,74},{ 33,74},{ 35,72},{ 43,80},
	{ 84,80},{ 92,72},{ 95,74},{ 98,74},{100,72},{108,80},{127,80},
};
#define N_GND_PTS	(sizeof gnd_pts / sizeof *gnd_pts)

/* n̈ʒu
 * (0:/1:E)
 */
const short base_pos[N_BASES][2] = {
	{ 31,73},{ 96,73},
};

/* Ẍʒu
 * (0:/1:/2:E/3:E)
 */
const short city_pos[N_CITIES][2] = {
	{  8,80},{ 53,80},{ 73,80},{118,80},
};

/* J[\L(1x1)
 * сF|00|
 * (0:/1:/2:/3:)
 */
#define N_CURSOR_PTN	4
const short cursor_ptn[N_CURSOR_PTN] = {
	/* EEÁE œ_ŁB͎gȂ */
	0x6f,0x7f,0x8f,/*0x9f*/0x7f,
};

/* nL(1x1)
 * сF|00 01 02|
 *       |10 11 12|
 * (0:c~TC1/1:c~TC2/.../9:c~TC10)
 */
#define N_BASE_PTN	10
const short base_ptn[N_BASE_PTN] = {
	0x60,0x63,0x66,0x69,0x6c,0x80,0x83,0x86,0x89,0x8c,
};

/* L
 * (0:a1/1:a2/.../7:a8)
 * * 0`3:(1x1)
 *   сF|00|
 * * 4`7(2x2)
 *   сF|00 01|
 *         |10 11|
 */
#define N_EXPL_PTN	8
const short expl_ptn[3][N_EXPL_PTN] = {
	{ 0xa0,0xa1,0xb0,0xb1, 0xa2,0xa4,0xa6,0xa8 }, /*  */
	{ 0xc0,0xc1,0xd0,0xd1, 0xc2,0xc4,0xc6,0xc8 }, /*  */
	{ 0xe0,0xe1,0xf0,0xf1, 0xe2,0xe4,0xe6,0xe8 }, /*  */
};

/* Ehp[^ */
#define N_ROUNDS	10
typedef struct _ROUND {
	int patr_spd;		/* }~TCxWi傫قǑj */
	int scud_cnt;		/* XJbh~TCoPʐ             */
	int scud_mul;		/* XJbh~TCo               */
	int scud_itv;		/* XJbh~TCoC^[o       */
	int scud_sec_min;	/* XJbh~TCBԁiŏj       */
	int scud_sec_max;	/* XJbh~TCBԁiőj       */
	int split_cnt_max;	/* XJbh~TCő啪           */
	int split_rate;		/* XJbh~TCmi番j     */
} ROUND;
const ROUND rounds[N_ROUNDS] = { /* <==========================================(((((Փx́Ãe[uōsĂI))))) */
/*0*/	{ 4,  4, 2, SEC(8), 18, 20, 0,   0 },
/*1*/	{ 4,  5, 2, SEC(8), 16, 19, 1,   2 },
/*2*/	{ 4,  6, 2, SEC(8), 14, 18, 1,   4 },
/*3*/	{ 5,  5, 2, SEC(7), 12, 17, 1,   6 },
/*4*/	{ 5,  6, 2, SEC(7), 10, 15, 1,   8 },
/*5*/	{ 5,  7, 2, SEC(7),  8, 13, 2,  10 },
/*6*/	{ 6,  6, 3, SEC(6),  6, 11, 2,  15 },
/*7*/	{ 6,  7, 3, SEC(6),  4,  8, 2,  20 },
/*8*/	{ 6,  8, 3, SEC(6),  3,  5, 2,  25 },
/*9*/	{ 9, 24, 9, SEC(1),  1,  2, 9, 999 },
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;

unsigned timer;			/* O[o^C} */
int joy;			/* WCpbh */
int hiscore;			/* nCXRA       */
int round_sel;			/* JnEhԍ */

int score;			/* ݂̃XRA                         */
int round_no;			/* ݂̃Ehԍ                   */
const ROUND* round;		/* ݂̃Ehp[^             */
int scud_mul;			/* XJbh~TCo񐔎c         */
int scud_itv;			/* XJbh~TCoC^[oc */

CURSOR cursor;			/* J[\ */
UNIT units[N_UNITS];		/* nEX */
EXPL expls[N_EXPLS];		/*      */
MISS patrs[N_PATRS];		/* }~TC     */
MISS scuds[N_SCUDS];		/* XJbh~TC */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void schedule();
void paint(int x0, int y0, int color);
int demo();
void game();
int units_disp(int obj);
void miss_work(MISS* miss);
void miss_erase(MISS* miss);
void expl_gen(int x, int y);
void expl_work(EXPL* expl);
int expl_disp(int obj, EXPL* expl);
UNIT* find_target();

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	FILEACC fa;

	/* nCXRA[hB */
	if(pceFileOpen(&fa, HISCORE_FNAME, FOMD_RD) != 0) goto L10;
	if(pceFileReadSct(&fa, &hiscore, 0, sizeof hiscore) != sizeof hiscore) {
		hiscore = 0;
		goto L20;
	}
	if(hiscore < 0 || SCORE_MAX < hiscore) hiscore = 0; /* ĂH */
L20:
	pceFileClose(&fa);
L10:

	/* V[hB */
	srand(pceTimerGetCount());

	/* OFeLXg`XvCg`OtBbNF */
	dispmode(1, 1, 1, 1, 0/*ʕ\Ȃ̂ŔwiF͖Ӗ*/);

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* nCXRAZ[uB */
	if(pceFileCreate(HISCORE_FNAME, sizeof hiscore) != 0) goto L30;
	if(pceFileOpen(&fa, HISCORE_FNAME, FOMD_WR) != 0) goto L30;
	if(pceFileWriteSct(&fa, &hiscore, 0, sizeof hiscore) != sizeof hiscore) {
		/* ݃G[AΏ悤ȂB */
	}
	pceFileClose(&fa);
L30:

	return;
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int pause, prev_joy, trg, i;
	char str[6 + 1]; /* uPAUSE!v̕(+nul)Z[up */

	pause = 0; /* |[YȂ0 */
REDO:

	/* [VSYNC҂B */
	if(prev == 0) prev = msec();
	do {
		cur = msec();
	} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
	prev = cur;

	/* pbhԎ擾B
	 * VvCuṕATRG_*ōKvB
	 */
	prev_joy = joy;
	joy = pad() & 0x00FF;
	trg = (joy ^ prev_joy) & joy;
	joy |= trg << 8;

	/* |[YȂ... */
	if(pause) {
		/* START{^ꂽ|[YB */
		if(joy & TRG_START) {
			sound(0);
			/* uPAUSE!v̕𕜌܂B */
			locate(5, 5);
			printstr(str);
			/* |[YB */
			pause = 0;
		} else {
			/* uPAUSE!v_ŕ\B */
			locate(5, 5);
			if(pause % SEC(0.25) < SEC(0.15)) {
				printstr("PAUSE!");
			} else {
				printstr("      ");
			}
			if(++pause == 0) pause = 1;
		}

	/* |[YłȂ... */
	} else {
		if(joy & TRG_START) {
			sound(0);
			/* uPAUSE!v̕Z[u܂B */
			for(i = 0; i < 6; i++) {
				str[i] = scan(5 + i, 5);
				if(str[i] == '\0') str[i] = ' '; /* dvI */
			}
			str[6] = '\0';
			/* |[Y}[NB */
			pause = 1;
		}
	}
	if(pause) goto REDO;

	/* O[o^C}i߂B */
	timer++;
}

/****************************************************************************
 *	paint
 ****************************************************************************/

/* (x0,y0)ƓF͈̔͂colorœhԂ܂B */
void
paint(int x0, int y0, int color)
{
#define N	64
	short stack[N][2];
	int i, x, y, x1, x2;
	unsigned char c;

	if(x0 < 0 || DISP_X - 1 < x0) return;
	if(y0 < 0 || DISP_Y - 1 < y0) return;
	c = point(x0, y0);
	stack[0][0] = x0;
	stack[0][1] = y0;
	i = 1;
	while(i != 0) {
		i--;
		x0 = stack[i][0];
		y0 = stack[i][1];
		if(point(x0, y0) == color) continue;
		x1 = x0;
		for(;;) {
			x1--;
			if(x1 < 0) break;
			if(point(x1, y0) != c) break;
		}
		x1++;
		x2 = x0;
		for(;;) {
			x2++;
			if(x2 > DISP_X - 1) break;
			if(point(x2, y0) != c) break;
		}
		x2--;
		for(x = x1; x <= x2; x++) {
			pset(x, y0, color);
		}
		if(y0 != 0) {
			y = y0 - 1;
			x = x1;
			for(;;) {
				for(;;) {
					if(x > x2) break;
					if(point(x, y) == c) break;
					x++;
				}
				if(x > x2) break;
				for(;;) {
					if(x > x2) break;
					if(point(x, y) != c) break;
					x++;
				}
				if(i < N) {
					stack[i][0] = x - 1;
					stack[i][1] = y;
					i++;
				}
			}
		}
		if(y0 != DISP_Y - 1) {
			y = y0 + 1;
			x = x1;
			for(;;) {
				for(;;) {
					if(x > x2) break;
					if(point(x, y) == c) break;
					x++;
				}
				if(x > x2) break;
				for(;;) {
					if(x > x2) break;
					if(point(x, y) != c) break;
					x++;
				}
				if(i < N) {
					stack[i][0] = x - 1;
					stack[i][1] = y;
					i++;
				}
			}
		}
	}

#undef N
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, i, j, x, y, obj;
	EXPL* expl;

	/* ʂNA܂B */
	cls();
	fill(0, 0, DISP_X - 1, DISP_Y - 1, 3);
	for(obj = 0; obj < N_OBJS; obj++) sppos(obj, -8, -8);

	/* ^Cg\B */
	x = (DISP_X - 8 * 13) / 2;
	y = (DISP_Y - 16 * 2) / 2;
	symbol(x + 1, y, " S I M P L E ", 1, 2);
	symbol(x    , y, " S I M P L E ", 1, 1);
	symbol(x - 1, y, " S I M P L E ", 1, 0);
	y += 16;
	symbol(x + 1, y, "M I S S I L E", 1, 2);
	symbol(x    , y, "M I S S I L E", 1, 1);
	symbol(x - 1, y, "M I S S I L E", 1, 0);

	/* nCXRA\B */
	locate(3, 0);
	siprintf("HI %06d", hiscore);

	/* ܂B */
	memset(expls, 0, sizeof expls);

	for(;;) {
		schedule();
		if(joy & TRG_A     ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }
		if((joy & (TRG_LF | TRG_DN)) && (0 < round_sel)) {
			round_sel--;
			sound(0);
		}
		if((joy & (TRG_RI | TRG_UP)) && (round_sel < N_ROUNDS - 1)) {
			round_sel++;
			sound(0);
		}

		/* JnEh\B */
		locate(5, 8);
		siprintf("ROUND%c", round_sel < 9 ? '1' + round_sel : 'X');

		/* vvg\B */
		if(timer % SEC(1) < SEC(0.75)) {
			locate(3,  9);
			printstr("[ A ] GAME");
			locate(3, 10);
			printstr("[SEL] EXIT");
		} else {
			locate(3,  9);
			printstr("          ");
			locate(3, 10);
			printstr("          ");
		}

		/* B */
		if(timer % SEC(0.2) == 0) {
			x = 16 + rnd(96);
			y = 24 + rnd(40);
			expl_gen(x, y);
		}
		/* B */
		obj = 0;
		for(j = 0, expl = expls; j < N_EXPLS; j++, expl++) {
			if(!expl->r) continue;
			expl_work(expl);
			if(!expl->r) continue;
			obj = expl_disp(obj, expl);
		}
		while(obj < N_OBJS) sppos(obj++, -8, -8);
	}

	/* Iړ_ŁB */
	sound(0);
	for(i = 0; i < SEC(1); i++) {
		schedule();
		if(timer % SEC(0.25) < SEC(0.15)) {
			if(result == 0) {
				locate(3,  9);
				printstr("[ A ] GAME");
			} else {
				locate(3, 10);
				printstr("[SEL] EXIT");
			}
		} else {
			locate(3,  9);
			printstr("          ");
			locate(3, 10);
			printstr("          ");
		}

		/* B */
		obj = 0;
		for(j = 0, expl = expls; j < N_EXPLS; j++, expl++) {
			if(!expl->r) continue;
			expl_work(expl);
			if(!expl->r) continue;
			obj = expl_disp(obj, expl);
		}
		while(obj < N_OBJS) sppos(obj++, -8, -8);
	}

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int i, j, k, n, x, y, obj, chr, city_left, chem_left;
	UNIT* unit;
	MISS* miss;
	EXPL* expl;

	/* XRAEEhB */
	score = 0;
	round_no = round_sel; /* fʂőIς */

	/* nEX܂B */
	memset(units, 0, sizeof units);
	unit = units;
	for(i = 0; i < N_BASES; i++, unit++) {
		unit->alive = BASE_CHAM_MAX;
		unit->x = base_pos[i][0];
		unit->y = base_pos[i][1];
	}
	for(i = 0; i < N_CITIES; i++, unit++) {
		unit->alive = 1;
		unit->x = city_pos[i][0];
		unit->y = city_pos[i][1];
	}

	for(;;) {
		/* Ehp[^B */
		round = &rounds[round_no < N_ROUNDS ? round_no : N_ROUNDS - 1];
		scud_mul = round->scud_mul; /* XJbh~TCo */
		scud_itv = 0; /* EhJn͂ɏo */

		/* ʂNA܂B */
		cls();
		fill(0, 0, DISP_X - 1, DISP_Y - 1, 3);
		for(obj = 0; obj < N_OBJS; obj++) sppos(obj, -8, -8);

		/* nʂ`܂B */
		for(i = 0; i < N_GND_PTS - 1; i++) {
			line(gnd_pts[i][0], gnd_pts[i][1], gnd_pts[i + 1][0], gnd_pts[i + 1][1], 1);
		}
		paint(0, DISP_Y - 1, 1);

		/* J[\܂B */
		memset(&cursor, 0, sizeof cursor);
		cursor.x = (CURSOR_X_MIN + CURSOR_X_MAX) / 2;
		cursor.y = (CURSOR_Y_MIN + CURSOR_Y_MAX) / 2;

		/* ܂B */
		memset(expls, 0, sizeof expls);

		/* }~TC܂B */
		memset(patrs, 0, sizeof patrs);

		/* XJbh~TC܂B */
		memset(scuds, 0, sizeof scuds);

		/* nEX\܂B */
		units_disp(0);

		/* XRAEEh\B */
		locate(3, 0);
		siprintf("1P %06d", score);
		for(i = 0; i < SEC(2); i++) {
			schedule();
			locate(5, 5);
			if(timer % SEC(0.25) < SEC(0.15)) {
				siprintf("ROUND%c", round_no < 9 ? '1' + round_no : 'X');
			} else {
				printstr("      ");
			}
		}
		cls();

		for(;;) {
			schedule();

			/* XJbh~TCoB */
			if(scud_mul != 0) {
				if(scud_itv == 0) {
					n = round->scud_cnt; /* o */
					for(i = 0, miss = scuds; i < N_SCUDS; i++, miss++) {
						if(miss->type) continue; /* gp */
						memset(miss, 0, sizeof(MISS));
						unit = &units[rnd(N_UNITS)]; /* o^[QbǵAĂ邩ǂɁAo */
						miss->type = MISS_TYPE_SCUD;
						miss->x = rnd(DISP_X);
						miss->y = 0;
						miss->sx = miss->x;
						miss->sy = miss->y;
						miss->dx = unit->x;
						miss->dy = unit->y;
						miss->spd = SEC(round->scud_sec_min) + rnd(SEC(round->scud_sec_max) - SEC(round->scud_sec_min) + 1);
						miss->target = unit;
						if(--n == 0) break; /* K萔o */
					}
					scud_mul--; /* o񐔂̎c炷 */
					scud_itv = round->scud_itv; /* o܂ł̃C^[oZbg */
				} else {
					scud_itv--; /* C^[oJEg_E */
				}
			}

			/* ncĂAJ[\ړ܂B */
			for(i = 0, unit = units; i < N_BASES; i++, unit++) {
				if(unit->alive) break;
			}
			if(i < N_BASES) {
				if(joy & PAD_LF) if((cursor.x -= CURSOR_SPD) < CURSOR_X_MIN) cursor.x = CURSOR_X_MIN;
				if(joy & PAD_RI) if((cursor.x += CURSOR_SPD) > CURSOR_X_MAX) cursor.x = CURSOR_X_MAX;
				if(joy & PAD_UP) if((cursor.y -= CURSOR_SPD) < CURSOR_Y_MIN) cursor.y = CURSOR_Y_MIN;
				if(joy & PAD_DN) if((cursor.y += CURSOR_SPD) > CURSOR_Y_MAX) cursor.y = CURSOR_Y_MAX;

				/* }~TCˁB */
				for(j = 0, unit = units; j < N_BASES; j++, unit++) {
					if(!unit->alive) continue; /* ~TCcʂȂ */
					if(!(joy & (j == 0 ? TRG_B : TRG_A))) continue; /* ˎwȂ */
					for(k = 0, miss = patrs; k < N_PATRS; k++, miss++) {
						if(!miss->type) break;
					}
					if(k == N_PATRS) continue; /* 󂫃GgȂ */
					unit->alive--; /* c~TC炷 */
					sound(1);
					/* }~TCB */
					memset(miss, 0, sizeof(MISS));
					miss->type = MISS_TYPE_PATR;
					miss->x = unit->x;
					miss->y = unit->y;
					miss->sx = unit->x;
					miss->sy = unit->y;
					miss->dx = cursor.x;
					miss->dy = cursor.y;
					x = (miss->dx - miss->sx);
					y = (miss->dy - miss->sy);
					n = (int)(sqrt(x * x + y * y) / round->patr_spd + 0.5);
					miss->spd = n != 0 ? n : 1;
				}
			}

			/* }~TCړB */
			for(i = 0, miss = patrs; i < N_PATRS; i++, miss++) {
				if(!miss->type) continue;
				miss_work(miss);
			}

			/* XJbh~TCړB */
			for(i = 0, miss = scuds; i < N_SCUDS; i++, miss++) {
				if(!miss->type) continue;
				miss_work(miss);
			}

			/* ړB */
			for(i = 0, expl = expls; i < N_EXPLS; i++, expl++) {
				if(!expl->r) continue;
				expl_work(expl);
			}

			/*==================== \ ====================*/
			obj = 0;

			/* \܂B */
			for(i = 0, expl = expls; i < N_EXPLS; i++, expl++) {
				if(!expl->r) continue;
				obj = expl_disp(obj, expl);
			}

			/* nEX\܂B */
			obj = units_disp(obj);

			/* cv[܂B(J[\\I) */
			while(obj < N_OBJS) sppos(obj++, -8, -8);

			/* ncĂAJ[\\܂B */
			for(i = 0, unit = units; i < N_BASES; i++, unit++) {
				if(unit->alive) break;
			}
			if(i < N_BASES) {
				x = cursor.x - CURSOR_CENT_X;
				y = cursor.y - CURSOR_CENT_Y;
				chr = cursor_ptn[timer / 2 % N_CURSOR_PTN];
				spdisp(OBJ_CURSOR, x, y, chr);
			}

			/* X̎c萔𐔂܂B */
			unit = units + N_BASES;
			city_left = 0;
			for(i = 0; i < N_CITIES; i++, unit++) {
				city_left += unit->alive;
			}

			/* `
			 * XcĂȂ΁Ac̃XJbh~TCoLZ܂B
			 * AʏɂXJbh~TCSAQ[I[o[ֈڍs܂B
			 * íȁ̕QƁj
			 */
			if(city_left == 0) scud_mul = 0;

			/* ʏ̃~TCƔSď... */
			n = 0;
			for(i = 0, miss = patrs; i < N_PATRS; i++, miss++) {
				if(miss->type) {
					n++;
					break;
				}
			}
			for(i = 0, miss = scuds; i < N_SCUDS; i++, miss++) {
				if(miss->type) {
					n++;
					break;
				}
			}
			for(i = 0, expl = expls; i < N_EXPLS; i++, expl++) {
				if(expl->r) {
					n++;
					break;
				}
			}
			if(n == 0) {
				if(scud_mul == 0) {
					/* o񐔂cĂȂ΁AXe[WIB
					 * a
					 * XcĂȂƂAscud_mul=0ɂȂĂ܂B
					 * í`̏̕QƁj
					 */
					break;
				} else {
					/* oC^[o[LZāAɎ̏oցB */
					scud_itv = 0;
				}
			}
		}

		/* mɃJ[\B */
		sppos(OBJ_CURSOR, -8, -8);

		/* }~TCƊX̎c萔𐔂܂B */
		unit = units;
		chem_left = 0;
		city_left = 0;
		for(i = 0; i < N_BASES; i++, unit++) {
			chem_left += unit->alive;
		}
		for(i = 0; i < N_CITIES; i++, unit++) {
			city_left += unit->alive;
		}

		/* XSłȂQ[I[o[B */
		if(city_left == 0) break;

		/* XRAvZB */
		sound(0);
		locate(3, 0);
		siprintf("1P %06d", score); /* ZÕXRA */
		for(i = 0; i < SEC(0.5); i++) schedule();
		sound(0);
		locate(2, 3);
		siprintf("%c%c*%3d *%4d", CHR_CHEM+0, CHR_CHEM+1, chem_left, (round_no + 1) *  10); /* }~TCc */
		for(i = 0; i < SEC(0.5); i++) schedule();
		sound(0);
		locate(2, 5);
		siprintf("%c%c*%3d *%4d", CHR_CITY+0, CHR_CITY+1, city_left, (round_no + 1) * 100); /* Xc */
		for(i = 0; i < SEC(0.5); i++) schedule();
		score += chem_left * (round_no + 1) *  10 + /* XRAZ */
			 city_left * (round_no + 1) * 100;
		if(score > SCORE_MAX) score = SCORE_MAX;
		sound(0);
		locate(3, 0);
		siprintf("1P %06d", score); /* Z̃XRA */
		for(i = 0; i < SEC(1.5); i++) schedule();

		/* Ehԍi߂܂B */
		round_no++;

		/* }~TC̐ɖ߂܂BX͐Ԃ܂B */
		for(i = 0, unit = units; i < N_BASES; i++, unit++) {
			unit->alive = BASE_CHAM_MAX;
		}
	}

	/* ŏIXRA\B */
	locate(3, 0);
	siprintf("1P %06d", score);
	for(i = 0; i < SEC(2); i++) {
		schedule();
		locate(4, 5);
		if(timer % SEC(0.25) < SEC(0.15)) {
			if(score > hiscore) {
				printstr("HISCORE!");
			} else {
				printstr("GAMEOVER");
			}
		} else {
			printstr("        ");
		}
	}
	if(score > hiscore) hiscore = score; /* nCXRAXV */
}

/****************************************************************************
 *	units_disp
 ****************************************************************************/

int
units_disp(int obj)
{
	int i, x, y, chr;
	UNIT* unit;

	unit = units;
	for(i = 0; i < N_BASES; i++, unit++) {
		if(!unit->alive) continue;
		x = unit->x - BASE_CENT_X;
		y = unit->y - BASE_CENT_Y;
		chr = base_ptn[unit->alive - 1];
		spdisp(obj++, x+ 0, y+ 0, chr+0x00); spdisp(obj++, x+ 8, y+ 0, chr+0x01); spdisp(obj++, x+16, y+ 0, chr+0x02);
		spdisp(obj++, x+ 0, y+ 8, chr+0x10); spdisp(obj++, x+ 8, y+ 8, chr+0x11); spdisp(obj++, x+16, y+ 8, chr+0x12);
	}
	for(i = 0; i < N_CITIES; i++, unit++) {
		if(!unit->alive) continue;
		x = unit->x - CITY_CENT_X;
		y = unit->y - CITY_CENT_Y;
		chr = CHR_CITY;
		spdisp(obj++, x+0, y, chr+0); spdisp(obj++, x+8, y, chr+1);
	}

	return obj;
}

/****************************************************************************
 *	miss_work
 ****************************************************************************/

void
miss_work(MISS* miss)
{
	int i, n, r, x, y, x1, y1, x2, y2, dx, dy;
	MISS* child[2];
	UNIT* unit;
	EXPL* expl;

	/* XJbh~TC̏ꍇ̂... */
	if(miss->type == MISS_TYPE_SCUD) {
		/* ̐eȂA܂B */
		if(miss->children != 0) return;

		/* B */
		if(miss->y < SPLIT_Y_MIN  || SPLIT_Y_MAX < miss->y) goto NO_SPLIT;
		if(round->split_cnt_max <= miss->split_cnt) goto NO_SPLIT;
		if(round->split_rate <= rnd(1000)) goto NO_SPLIT;

		/* 󂫃GgT܂B */
		n = 0;
		for(i = 0; i < N_SCUDS; i++) {
			if(!scuds[i].type) {
				child[n++] = &scuds[i];
				if(n == 2) break;
			}
		}
		/* 󂫃Gg... */
		if(n == 2) {
			for(i = 0; i < 2; i++) {
				memset(child[i], 0, sizeof(MISS));
				unit = find_target();
				child[i]->type = MISS_TYPE_SCUD;
				child[i]->x = miss->x;
				child[i]->y = miss->y;
				child[i]->sx = miss->x;
				child[i]->sy = miss->y;
				child[i]->dx = unit->x;
				child[i]->dy = unit->y;
				child[i]->spd = miss->spd - miss->cnt;
				if(child[i]->spd == 0) child[i]->spd = 1; /* 肦ȂƎvÔ */
				child[i]->target = unit;
				child[i]->parent = miss;
				child[i]->split_cnt = miss->split_cnt + 1;
				miss->children++;
			}
			return;
		}
NO_SPLIT:
	}

	/* oߎԂi߂܂B */
	miss->cnt++;

	/* Öʒu獡̈ʒuցAOՂ`܂B */
	x1 = miss->x;
	y1 = miss->y;
	x2 = miss->sx + (miss->dx - miss->sx) * miss->cnt / miss->spd;
	y2 = miss->sy + (miss->dy - miss->sy) * miss->cnt / miss->spd;
	line(x1, y1, x2, y2, miss->type == MISS_TYPE_PATR ? 1 : 2);
	miss->x = x2;
	miss->y = y2;

	/* eH */
	if(miss->cnt == miss->spd) {
		/* XJbh~TCȂAjbgjB */
		if(miss->type == MISS_TYPE_SCUD) {
			miss->target->alive = 0; /* alive=0łȂ */
		}
		/* B */
		expl_gen(miss->x, miss->y);
		sound(2);
		/* ŁB */
		miss_erase(miss);
		return;
	}

	/* XJbh~TC̏ꍇ̂... */
	if(miss->type == MISS_TYPE_SCUD) {
		/* ڐGH */
		for(i = 0, expl = expls; i < N_EXPLS; i++, expl++) {
			if(!expl->r) continue;
			r = expl->r - 1;
			x = expl->x;
			y = expl->y;
			if(x2 < x - r || x + r < x2 ||
			   y2 < y - r || y + r < y2) continue; /* ` */
			dx = x - x2;
			dy = y - y2;
			if(dx * dx + dy * dy > r * r) continue; /* ~ */
			/* B */
			expl_gen(miss->x, miss->y);
			sound(2);
			/* ŁB */
			miss_erase(miss);
			return;
		}
	}
}

/****************************************************************************
 *	miss_erase
 ****************************************************************************/

void
miss_erase(MISS* miss)
{
	int i, x1, y1, x2, y2;

	/* OՂB */
	x1 = miss->sx;
	y1 = miss->sy;
	for(i = 1; i <= miss->cnt; i++) {
		x2 = miss->sx + (miss->dx - miss->sx) * i / miss->spd;
		y2 = miss->sy + (miss->dy - miss->sy) * i / miss->spd;
		line(x1, y1, x2, y2, 3);
		x1 = x2;
		y1 = y2;
	}

	/* XJbh~TC̏ꍇ̂... */
	if(miss->type == MISS_TYPE_SCUD) {
		/* ̎qȂAeJEg炵āA
		 * ẽJEg0ɂȂAeŁB
		 */
		if(miss->parent && --miss->parent->children == 0) {
			/* e͔𐶐ȂB */
			miss_erase(miss->parent);
		}
	}

	/* GgJB */
	miss->type = 0;
}

/****************************************************************************
 *	expl_gen
 ****************************************************************************/

void
expl_gen(int x, int y)
{
	int i;
	EXPL* expl;

	/* 󂫃GgTB */
	for(i = 0, expl = expls; i < N_EXPLS; i++, expl++) {
		if(!expl->r) break;
	}
	if(i == N_EXPLS) return; /* 󂫃GgȂ */

	memset(expl, 0, sizeof(EXPL));
	expl->r   = 1;
	expl->x   = x;
	expl->y   = y;
	expl->cnt = 1 << 8; /* Ȃr=0ɂȂȂ悤 */
}

/****************************************************************************
 *	expl_work
 ****************************************************************************/

void
expl_work(EXPL* expl)
{
	expl->cnt += EXPL_SPD;
	expl->r = expl->cnt >> 8;
	if(expl->r < 8) {		/* 0,1,2,3,4,5,6,7 */
		/* ̂܂ */
	} else if(expl->r < 12) {	/* 8,8,8,8 */
		expl->r = 8;
	} else {			/* 7,6,5,4,3,2,1,0 */
		expl->r = 19 - expl->r;
	}
	if(expl->r < 0) expl->r = 0;
}

/****************************************************************************
 *	expl_disp
 ****************************************************************************/

int
expl_disp(int obj, EXPL* expl)
{
	int r, x, y, chr;

	r = expl->r - 1;
	x = expl->x - r;
	y = expl->y - r;
	chr = expl_ptn[rnd(3)][r];
	if(r < 4) {
		spdisp(obj++, x, y, chr);
	} else {
		spdisp(obj++, x+0, y+0, chr+0x00); spdisp(obj++, x+8, y+0, chr+0x01);
		spdisp(obj++, x+0, y+8, chr+0x10); spdisp(obj++, x+8, y+8, chr+0x11);
	}

	return obj;
}

/****************************************************************************
 *	find_target
 ****************************************************************************/

UNIT*
find_target()
{
	UNIT *unit, *targets[N_UNITS];
	int i, n;

	/* cĂ郆jbg𒊏o܂B */
	n = 0;
	for(i = 0, unit = units; i < N_UNITS; i++, unit++) {
		if(!unit->alive) continue;
		targets[n++] = unit;
	}

	/* cĂȂ΃_ŁB */
	if(n == 0) return &units[rnd(N_UNITS)];

	/* cĂ郆jbg̒烉_ŁB */
	return targets[rnd(n)];
}

